option explicit
class clsInvoluteArgs
	public UserAction
	public tCX, tCY , tRev , tDelta , tNumV 
end class


Class InvoluteDialog


	public InvoluteArgs	' NOTE!!!! Initialised in class_initialise


	'============================================================
	' Put your Button descriptors here
	'------------------------------------------------------------
	Private Sub Class_Initialize

		ScriptType = 	"vbs"	'"html"
		ThisClassName = "InvoluteDialog"	'(Must be the same as class statement above)
		ToolTipText = 	"Create Involute Curve (dialog)"
		ImageURL = 	"ButtonImages\Involute.GIF"
		LinkURL =	""	'"BC_Involute.html"
		set InvoluteArgs = new clsInvoluteArgs
			InvoluteArgs.tCX=0
			InvoluteArgs.tCY=0
			InvoluteArgs.tRev=4
			InvoluteArgs.tDelta=1
			InvoluteArgs.tNumV=1000
	End Sub
	'------------------------------------------------------------



	'============================================================
	' Place actual script in this sub (do not rename)
	'------------------------------------------------------------

	
		Public Sub ExecScript

			showmodaldialog "BC_InvoluteDialog.html", InvoluteArgs, "dialogWidth:250px; dialogHeight:300px"
			
			
			if InvoluteArgs.UserAction="OK" then
				
				Dim ActiveDrawing, UndoRec
				Set ActiveDrawing = Application.ActiveDrawing

				Dim i , tGr , tA , tX , tY 

				set undorec = ActiveDrawing.AddUndoRecord("Involute Curve")
				Set tGr = ActiveDrawing.Graphics.Add(imsiPolyline)

				For i = 0 To InvoluteArgs.tNumV
		            
					' ===== This section applies the formula =====
		                
					tA = i * InvoluteArgs.tRev / InvoluteArgs.tNumV * 2 * 3.14159265358979   '(VB functions use radians)
					tX = InvoluteArgs.tCX + InvoluteArgs.tDelta * (Cos(tA) + tA * Sin(tA))
					tY = InvoluteArgs.tCY + InvoluteArgs.tDelta * (Sin(tA) - tA * Cos(tA))
		            
					' ============================================
		            
					tGr.Vertices.Add tX, tY, 0
				Next

				UndoRec.AddGraphic tGr
				undorec.close
				Set tGr = Nothing

				ActiveDrawing.ActiveView.Refresh
			end if
			
			
			
		End Sub

	'------------------------------------------------------------



	'============================================================
	' This parts same for all classes. Do not change !!!!
	'------------------------------------------------------------

		public ThisClassName
		public ToolTipText
		public ImageURL
		public LinkURL
		public ScriptType
		

	'------------------------------------------------------------



End Class
