option explicit
class clsImportFilterArgs
	public UserAction
	public FName, Filter, ObjType, HLines, ColX, ColY, ColZ
end class


Class ImportFilter
	public ImportFilerArgs

	'============================================================
	' Put your Button descriptors here
	'------------------------------------------------------------
	Private Sub Class_Initialize

		ScriptType = 	"vbs"	'"html"
		ThisClassName = "ImportFilter"	'(Must be the same as class statement above)
		ToolTipText = 	"Collection on Import Filters"
		ImageURL = 	"ButtonImages\ImportFilter.GIF"
		LinkURL =		""	'"BC_ImportFilter.html"
		set ImportFilerArgs = new clsImportFilterArgs
			ImportFilerArgs.FName =""
			ImportFilerArgs.Filter ="GenericXYZ"
			ImportFilerArgs.ObjType ="Polyline"
			ImportFilerArgs.HLines =0
			ImportFilerArgs.ColX =1
			ImportFilerArgs.ColY =2
			ImportFilerArgs.ColZ =3
	End Sub
	'------------------------------------------------------------



	'============================================================
	' Place actual script in this sub (do not rename)
	'------------------------------------------------------------


		Public Sub ExecScript

			showmodaldialog "BC_ImportFilter.html", ImportFilerArgs, "dialogWidth:450px; dialogHeight:400px"
			if ImportFilerArgs.UserAction="OK" then
			'msgbox ImportFilerArgs.UserAction

				Dim ActiveDrawing, UndoRec
				Set ActiveDrawing = Application.ActiveDrawing

				dim WshShell, fso, tfile,  ts
				Set WshShell = CreateObject("WScript.Shell")
				Set fso = CreateObject("Scripting.FileSystemObject")
				
				
				if fso.FileExists(ImportFilerArgs.FName) then
					Set tfile = fso.GetFile(ImportFilerArgs.FName)
					set ts = tfile.openastextstream()
					If ImportFilerArgs.Filter="Faro1" then
						ImportFaro1 ts, ActiveDrawing
					ElseIf ImportFilerArgs.Filter="Faro2" then
						ImportFaro2 ts, ActiveDrawing
					ElseIf ImportFilerArgs.Filter="GenericXYZ" then
						ImportGeneric1 ts, ActiveDrawing
					End If
					ts.close
				else
					msgbox "File doesn't exist"
				end if

				ActiveDrawing.ActiveView.Refresh

			end if		
		End Sub

	'------------------------------------------------------------



	'============================================================
	' This parts same for all classes. Do not change !!!!
	'------------------------------------------------------------

		public ThisClassName
		public ToolTipText
		public ImageURL
		public LinkURL
		public ScriptType
		

	'------------------------------------------------------------




		


    Function ParseLine(t, delim, Index, doclean)
		on error resume next
        Dim i, x0, x1
        For i = 1 To Index
            x0 = x1
            x1 = InStr(x1 + 1, t, delim)
        Next
        if x1<>0 then
			ParseLine = Trim(Mid(t, x0 + 1, x1 - x0 - 1))
		else
			ParseLine = Trim(mid(t, x0 + 1))
		end if
        if doclean then
			if IsNumeric(ParseLine) then ParseLine = ParseLine +0
		end if
        
    End Function


	Sub ImportFaro1(ts, ActiveDrawing) 
		on error resume next

        Dim t, x0, y0, z0, x1, y1, z1, n, r0, gr

        Do Until ts.AtEndOfStream
            t = ts.ReadLine
            If UCase(Right(t, 4)) = "LINE" Then
                n = ParseLine(t, ",", 1, true)
                x0 = ParseLine(t, ",", 2, true)
                y0 = ParseLine(t, ",", 3, true)
                z0 = ParseLine(t, ",", 4, true)
                x1 = ParseLine(t, ",", 8, true)
                y1 = ParseLine(t, ",", 9, true)
                z1 = ParseLine(t, ",", 10, true)
                Set gr = ActiveDrawing.Graphics.AddLineSingle(x0, y0, z0, x1, y1, z1)
                gr.Properties("Info") = n
				Set gr = Nothing
            ElseIf UCase(Right(t, 6)) = "CIRCLE" Then
                n = ParseLine(t, ",", 1, true)
                x0 = ParseLine(t, ",", 2, true)
                y0 = ParseLine(t, ",", 3, true)
                z0 = ParseLine(t, ",", 4, true)
                r0 = ParseLine(t, ",", 43, true)
                Set gr = ActiveDrawing.Graphics.AddCircleCenterAndPoint(x0, y0, z0, x0 + r0, y0, z0)
                gr.Properties("Info") = n
				Set gr = Nothing
            ElseIf UCase(Right(t, 5)) = "POINT" Then
                n = ParseLine(t, ",", 1, true)
                x0 = ParseLine(t, ",", 2, true)
                y0 = ParseLine(t, ",", 3, true)
                z0 = ParseLine(t, ",", 4, true)
                Set gr = ActiveDrawing.Graphics.AddCross(x0, y0, z0)
                gr.Properties("Info") = n
				Set gr = Nothing
            ElseIf UCase(Right(t, 6)) = "PLNPNT" Then
                n = ParseLine(t, ",", 1, true)
                x0 = ParseLine(t, ",", 2, true)
                y0 = ParseLine(t, ",", 3, true)
                z0 = ParseLine(t, ",", 4, true)
                Set gr = ActiveDrawing.Graphics.AddCross(x0, y0, z0)
                gr.Properties("Info") = n
				Set gr = Nothing
            End If
        Loop

	End Sub

	Sub ImportFaro2(ts, ActiveDrawing) 
		on error resume next

        Dim t, x0, y0, z0, x1, y1, z1, n, r0, gr

        t = ts.ReadLine
        
        Do Until ts.AtEndOfStream
            t = ts.ReadLine
                n = ParseLine(t, " ", 1, true)
                x0 = ParseLine(t, " ", 2, true)
                y0 = ParseLine(t, " ", 3, true)
                z0 = ParseLine(t, " ", 4, true)
                Set gr = ActiveDrawing.Graphics.AddCross(x0, y0, z0)
                gr.Properties("Info") = n
				Set gr = Nothing
        Loop

	End Sub

	Sub ImportGeneric1(ts, ActiveDrawing) 
		on error resume next
        Dim i,t, x0, y0, z0, x1, y1, z1, n, r0, gr, grt

        
        for i = 1 to ImportFilerArgs.HLines
			t = ts.ReadLine
		next
		
		if ImportFilerArgs.ObjType="Polyline" then
			grt=false
			Do Until ts.AtEndOfStream
				t = ts.ReadLine
				x0 = ParseLine(t, ",", ImportFilerArgs.ColX, false)
				y0 = ParseLine(t, ",", ImportFilerArgs.ColY, false)
				z0 = ParseLine(t, ",", ImportFilerArgs.ColZ, false)
				if x0<>"" and y0<>"" and z0<>"" then
					x0 = ParseLine(t, ",", ImportFilerArgs.ColX, true)
					y0 = ParseLine(t, ",", ImportFilerArgs.ColY, true)
					z0 = ParseLine(t, ",", ImportFilerArgs.ColZ, true)
					if grt then
						gr.Vertices.Add x0,y0,z0
					else
						Set gr = ActiveDrawing.Graphics.Add (imsiPolyline)		'Makes a polyline by default
						grt=true
						gr.Vertices.Add x0,y0,z0
					end if
				else
					if grt then
						set gr=nothing
						grt=false
					end if
				end if
				
			Loop
			Set gr = Nothing
		elseif ImportFilerArgs.ObjType="Point" then
			Do Until ts.AtEndOfStream
				t = ts.ReadLine
				x0 = ParseLine(t, ",", ImportFilerArgs.ColX, false)
				y0 = ParseLine(t, ",", ImportFilerArgs.ColY, false)
				z0 = ParseLine(t, ",", ImportFilerArgs.ColZ, false)
				if x0<>"" and y0<>"" and z0<>"" then
					x0 = ParseLine(t, ",", ImportFilerArgs.ColX, true)
					y0 = ParseLine(t, ",", ImportFilerArgs.ColY, true)
					z0 = ParseLine(t, ",", ImportFilerArgs.ColZ, true)
					ActiveDrawing.Graphics.AddCross x0,y0,z0
				end if
			Loop
		end if
	End Sub


End Class

